(defproject wanijo "0.3.0"
  :description "Graph Database via UI"
  :url "https://gitea.heevyis.ninja/josha/wanijo"
  :min-lein-version "2.0.0"

  :dependencies [;;clojure core
                 [org.clojure/clojure "1.10.0"]

                 ;; static site
                 [compojure "1.6.1"]
                 [ring/ring-defaults "0.3.2"]
                 [ring/ring-jetty-adapter "1.7.1"
                  :exclusions [ring/ring-core
                               ring/ring-codec
                               commons-io
                               commons-codec]]
                 [ring/ring-json "0.4.0"]
                 [hiccup "1.0.5"]
                 [joshavg/formulare "0.4.0"]

                 ;; neo4j
                 [gorillalabs/neo4j-clj "2.0.1"
                  :exclusions [org.bouncycastle/bcprov-jdk15on
                               org.bouncycastle/bcpkix-jdk15on
                               com.github.ben-manes.caffeine/caffeine]]

                 ;; additional server side libs
                 [buddy/buddy-hashers "1.3.0"
                  :exclusions [commons-codec]]
                 [clj-time "0.15.1"]
                 [markdown-clj "1.0.7"]
                 [dorothy "0.0.7"]]

  :profiles {:dev {:dependencies [;; webserver stuff
                                  [javax.servlet/servlet-api "2.5"]
                                  [ring/ring-mock "0.3.2"]
                                  [ring/ring-devel "1.7.1"
                                   :exclusions [ring/ring-core
                                                ring/ring-codec
                                                commons-io
                                                commons-codec]]]
                   :plugins [;; neo4j db
                             [joshavg/lein-neo4j "0.5.0"]

                             ;; webserver stuff
                             [lein-less "1.7.5"]
                             [lein-ring "0.12.5"]

                             ;; code quality
                             [lein-ancient "LATEST"]
                             [jonase/eastwood "LATEST"]
                             [lein-bikeshed "LATEST"]
                             [lein-cloverage "LATEST"]
                             [cider/cider-nrepl "LATEST"]
                             [lein-kibit "LATEST"]]}
             :uberjar {:aot :all
                       :main wanijo.main}}

  :neo4j {:path "neo4j"}
  :repl-options {:init-ns wanijo.framework.repl}
  :ring {:handler wanijo.handler/app}
  :less {:source-paths ["resources/app/stylesheets"]
         :target-path "resources/public/css"}
  :aliases {"uberjar" ["do" ["less" "once"] "uberjar"]
            "compile" ["do" ["less" "once"] "compile"]}
  :hiera {:cluster-depth 2}
  :eastwood {:namespaces [:source-paths]})
