module Explore exposing (Msg(..), main, update, view)

import Browser
import Html exposing (Html, button, div, node, text)
import Html.Attributes exposing (type_)
import Html.Events exposing (onClick)


main =
    Browser.sandbox { init = 0, update = update, view = view }


type Msg
    = Increment
    | Decrement


update msg model =
    case msg of
        Increment ->
            model + 1

        Decrement ->
            model - 1


withStyle html =
    div []
        [ node "style"
            [ type_ "text/css" ]
            [ text "@import url(/resources/public/css/app.css)" ]
        , html
        ]


view model =
    div []
        [ button [ onClick Decrement ] [ text "-" ]
        , div [] [ text (String.fromInt model) ]
        , button [ onClick Increment ] [ text "+" ]
        ]
        |> withStyle
