(ns wanijo.visualisation.routes
  (:require [compojure.core :refer [defroutes wrap-routes
                                    GET POST DELETE]]
            [ring.util.response :as resp]
            [wanijo.framework.routing :refer [register! path]]
            [wanijo.framework.view :as view]
            [wanijo.instance.domain :as domain-instance]
            [wanijo.schema.domain :as domain-schema]
            [wanijo.visualisation
             [domain :as vis-domain]
             [viz :as viz]
             [view :as vis-view]]))

(defn all-instances [req]
  (view/layout!
   :request req
   :content
   [[:h1 "All Instances"]
    (viz/all-instances (vis-domain/all-instance-connections!))]))

(defn all-schemas [req]
  {:content-type "text/json"
   :body (domain-schema/accessible-schemas! (-> req :session :uuid))})

(defroutes routes
  (GET (register! :vis-explore "/vis/explore/:instance-uuid")
       [:as req]
       (vis-view/index req))
  (GET (register! :vis-all-instances "/vis/all-instances")
       [:as req]
       (all-instances req))
  (GET (register! :vis-all-schemas "/api/vis/schemas")
       [:as req]
       (all-schemas req)))
